<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 26/12/2014
 * Time: 10:15
 */

namespace Folha\Facade\Relatorios;

class relatoriosAdmissao {
    //Constante para o list dos relatórios
    const relat = 'LISTARELATORIOS';
    //Constantes para os nomes dos fields.
    const nrOrg = 'NRORG';
    const compe = 'MESCOMPETENCIA';
    const moCal = 'MODALIDCAL'; //Na tela é exibido o campo MODALIDCAL_NOME, mas usa-se este para os relatórios.
    const moSal = 'MODALIDSAL'; //todo Modalidade de salário está exibindo o nome também (como o madalidade de cálculo). Se necessário fazer o mesmo que feito no Modalidade de Cálculo
    const ocorr = 'OCORRECAL';
    const cdOpe = 'CDOPERADOR';
    const nmOpe = 'NMOPERADOR';
    const confi = 'CONFIDENCIAL';
    const vincu = 'NRVINCULO';
    const nmVin = 'NMVINCULO';
    const esLeg = 'ESTRUTLEGAL';
    const esGer = 'ESTRUTGEREN';
    const dtIni = 'DATAINICIO';
    const dtFim = 'DATAFINAL';
    const tpEst = 'TIPOESTRUTURA';
    const zebra = 'ZEBRADO';
    //Constantes para as mensagens
    //Mensagem que alerta a falta de seleção de um relatório
    const msgSelRel = 'hrm_relatorio_folha_selecao';
    //Mensagem que alerta da não necessidade de se eselecionar mais de um parâmetro entre vínculo e estruturas legal e gerencial
    const msgMulEst = 'hrm_relatorio_folha_multipla';
    //Mensagem de erro da falta de preechimento de campos obrigatórios
    const msgFalPre = 'hrm_relatorio_folha_preencher';
    //Mensagem nome do relatório inválido ou o mesmo não está integrado
    const msgNomInv = 'hrm_relatorio_folha_nome_relatorio';
    //Mensagem de ausência de manual de relatório
    const msgSemMan = 'hrm_relatorio_folha_sem_manual';
    //Mensagem de alerta de relatório não disponível para a organização em questão
    const msgSemRel = 'hrm_relatorio_folha_sem_relatorio';
    //Atributos
    private $nomeRelatorio;     //Nome do relatório
    private $nrOrganizacao;     //Número da organização
    private $cdOperador;        //Código do Operador
    private $nroVinculo;        //Número do vínculo
    private $nomeVinculo;       //Nome do Vínculo
    //Array dos campos que podem ser setados para visíveis, invisíveis, requeridos ou não requeridos.
    private $campos = array(self::vincu, self::esLeg, self::esGer, self::dtIni, self::dtFim, self::tpEst, self::zebra);
    //Array de RESET dos labels do campos alterados. IMPORTANTE registrar os labels originais dos campos alterados
    private $labels = array(self::dtIni=>'Data Inicial da Admissão', self::dtFim=>'Data Final da Admissão',
        self::tpEst=>'Tipo de Estrutura');
    //Array com os relatórios e suas configurações
    private $relatorios = array(
        'kit_admissional'=>array(
            'requer'=>array(self::tpEst, self::vincu),
            'parame'=>array(self::nrOrg=>'P_NRORG',self::compe=>'P_COMPETENCIA',self::vincu=>'P_VINCULO',self::tpEst=>'P_NRTPEMPRESA',self::zebra=>'ZEBRADO',self::confi=>'P_CONFIDENCIAL',self::cdOpe=>'CDOPERADOR',self::nmOpe=>'NMOPERADOR'),
            'rotulo'=>array(self::tpEst=>'Tipo de estrutura da empresa'),
            'manual'=>null ),
        'folha_ponto'=>array(
            'requer'=>null,
            'parame'=>array(self::nrOrg=>'P_NRORG',self::esLeg=>'P_NRESTRUTURA',self::vincu=>'P_NRVINCULOM',self::compe=>'P_COMPETENCIA',self::dtIni=>'P_COMPPONTO'),
            'rotulo'=>array(self::dtIni=>'Outra Competência para o Período de Apuração'),
            'manual'=>null ),
        'registro_empregado'=>array(
            'requer'=>array(self::tpEst),
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_ESTRUTGEREN',self::vincu=>'P_VINCULO',self::dtIni=>'P_DTINICIO',self::dtFim=>'P_DTFINAL',self::zebra=>'ZEBRADO',self::confi=>'P_CONFIDENCIAL',self::tpEst=>'P_NRTPEMPRESA'),
            'rotulo'=>null,
            'manual'=>null ),
        'contrato_trabalho_regime_experiencia'=>array(
            'requer'=>array(self::tpEst),
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::esLeg=>'P_NRESTRUTLEGAL',self::vincu=>'P_VINCULO',self::confi=>'P_CONFIDENCIAL',self::esGer=>'P_NRESTRUTGEREN',self::dtIni=>'P_DTINICIO',self::dtFim=>'P_DTFINAL',self::tpEst=>'P_NRTPEMPRESA',self::cdOpe=>'CDOPERADOR',self::nmOpe=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>null ),
        'controle_contrato_experiencia'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::vincu=>'P_VINCULO',self::zebra=>'ZEBRADO',self::esLeg=>'P_NRESTRUTLEGAL',self::confi=>'P_CONFIDENCIAL' ),
            'rotulo'=>null,
            'manual'=>null ),
        'declaracao_vale_alimentacao'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::confi=>'P_CONFIDENCIAL',self::cdOpe=>'CDOPERADOR',self::nmOpe=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>null ),
        'declaracao_vale_transporte'=>array(
            'requer'=>null,
            'parame'=>array(self::nrOrg=>'P_NRORG',self::vincu=>'P_VINCULO',self::compe=>'P_COMPETENCIA',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTGEREN',self::dtIni=>'P_DTINICIO',self::dtFim=>'P_DTFINAL',self::confi=>'P_CONFIDENCIAL',self::cdOpe=>'CDOPERADOR',self::nmOpe=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>null ),
        'declaracao_recebimento_vale_transporte'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::zebra=>'ZEBRADO',self::confi=>'P_CONFIDENCIAL',self::cdOpe=>'CDOPERADOR',self::nmOpe=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>null ),
        'etiqueta_cartao_ponto'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::vincu=>'P_VINCULO',self::esGer=>'P_ESTRUTGEREN',self::esLeg=>'P_ESTRUTLEGAL'),
            'rotulo'=>null,
            'manual'=>null ),
        'etiqueta'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_DTMESCOMPETENC',self::nrOrg=>'P_NRORG',self::esLeg=>'P_NRESTRUTLEGAL',self::vincu=>'P_NRVINCULO',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_DTINIADM',self::dtFim=>'P_DTFIMADM',self::confi=>'P_CONFIDENCIAL'),
            'rotulo'=>null,
            'manual'=>null ),
        'etiqueta2'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_DTMESCOMPETENC',self::nrOrg=>'P_NRORG',self::esLeg=>'P_NRESTRUTLEGAL',self::vincu=>'P_NRVINCULO',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_DTINIADM',self::dtFim=>'P_DTFIMADM',self::confi=>'P_CONFIDENCIAL'),
            'rotulo'=>null,
            'manual'=>null ),
        'etiqueta3'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::esLeg=>'P_NRESTRUTLEGAL',self::vincu=>'P_VINCULO',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_DTINIADM',self::dtFim=>'P_DTFIMADM',self::confi=>'P_CONFIDENCIAL'),
            'rotulo'=>null,
            'manual'=>null ),
        'declaracao_encargos_familia_imposto_de_renda'=>array(
            'requer'=>null,
            'parame'=>array(self::compe=>'P_DTMESCOMPETENC',self::nrOrg=>'P_NRORG',self::vincu=>'P_NRVINCULO',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTGEREN',self::zebra=>'ZEBRADO',self::confi=>'P_CONFIDENCIAL',self::dtIni=>'P_DTINICIO',self::dtFim=>'P_DTFINAL',self::cdOpe=>'CDOPERADOR',self::nmOpe=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>null ),
        'ficha_salario_familia'=>array(
            'requer'=>null,
            'parame'=>array(self::nrOrg=>'P_NRORG',self::compe=>'P_COMPETENCIA',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::confi=>'P_CONFIDENCIAL'),
            'rotulo'=>null,
            'manual'=>null ),
        'termo_prorrogacao'=>array(
            'requer'=>array(self::tpEst, self::vincu),
            'parame'=>array(self::compe=>'P_COMPETENCIA',self::nrOrg=>'P_NRORG',self::tpEst=>'P_NRTPEMPRESA',self::vincu=>'P_VINCULO',self::confi=>'P_CONFIDENCIAL'),
            'rotulo'=>null,
            'manual'=>null ),
        /*'nome_do_relatório'=>array(
            'requer'=>null,
            'parame'=>array(null),
            'rotulo'=>null,
            'manual'=>"<strong>TÍTULO destacado</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">1º parágrafo.<p align=\"justify\" style=\"text-indent: 20px;\">2º parágrafo." ),*/
    );

    public function  __construct(){       //Construtor
        $this->nomeRelatorio = tk_get_field_value(self::relat);
        $this->nrOrganizacao = tk_get_field_value(self::nrOrg);
        $this->cdOperador    = tk_get_field_value(self::cdOpe);
        $this->nroVinculo    = tk_get_field_value(self::vincu);
        $this->nomeVinculo   = tk_get_field_value(self::nmVin);
    }

    /**
     * Função de customização. Relatórios que possuem alguma tratativa em específico. Retorna true indicando que a
     * função seguinte (por exemplo: abrirRelatorio) pode continuar a execução normalmente; e o retorno false indica
     * que a função seguinte deve abortar a execução.
     *
     * @param array $parametros
     * @return bool
     */
    private function customizacao($parametros){
        switch($this->nomeRelatorio){
            case 'kit_admissional':        //Faz o download de alguns relatórios em zip
                $kit = array();
                $kit[] = 'declaracao_vale_transporte';
                $kit[] = 'termo_prorrogacao';
                $kit[] = 'contrato_trabalho_regime_experiencia';
                $kit[] = 'registro_empregado';
                $kit[] = 'controle_contrato_experiencia';
                $kit[] = 'declaracao_vale_alimentacao';
                $kit[] = 'ficha_salario_familia';
                $kit[] = 'etiqueta3';
                $res = \Folha\Util\Facade::downloadPacoteRelatoriosZip(
                    $kit,                   //Arrays com os relatórios
                    $parametros,
                    'tmp_kits',             //pasta para gravação temporária dos arquivos
                    'kit_admissao_'.$this->nroVinculo.'_'.$this->nomeVinculo, //Nome do arquivo
                    $this->nrOrganizacao,   //Organização (para criação de subpastas na pasta temporária)
                    $this->cdOperador);     //Operador (para criação de subpastas na pasta temporária)
                if($res != null)        //Verifica se ocorreu algum erro na geração do Kit Admissional
                    tk_warning('Ocorreu o seguinte erro na geração do Kit Admissional: '.$res);
                return false;   //Aborta a execução da rotina normal
                break;
            /*case 'nome_interno_relatorio': //EXEMPLO!!
                //código de customização
                \Folha\Util\Facade::downloadRelatorio($parametros,
                    $this->nomeRelatorio,
                    'tmp_beneficios',
                    'alelo',
                    'txt',
                    $this->nrOrganizacao,
                    $this->cdOperador,
                    'txt',
                    'frameset');
                return true;    //Continua a execução da rotina normal
                return false;   //Aborta a execução da rotina normal
                //ATENÇÂO: usar return true e false no código
                break;*/
        }
        return true;    //Indica que pode cotinuar a execução
    }

    //private function compacta()

    /*
     * FUNÇÕES PARA USO DA FACADE
     */

    public function mostrarCampos(){ //Mostra os campos necessário para o relatório em questão. Também seta os campos requeridos. Exibe mensagem de erro se o relatório não existir.
        $nome = $this->nomeRelatorio;
        foreach($this->campos as $aux){         //Todos invisíveis, não requeridos e valores reiniciados
            tk_set_invisible_field($aux);       //Invisível
            //tk_set_visible_field($aux);       //todo Descomentar isto apenas para debug!!!
            tk_set_field_not_required($aux);    //Não requerido
            tk_set_field_value($aux, '');       //Limpa valores dos campos
        }
        if($nome == 'inicio' || $nome == null){   //Se não houver seleção este ignora e não executa os demais
            return;
        }
        if(isset($this->relatorios[$nome])){        //Verifica se existe o relatório no array de configuração
            $relatSelec = $this->relatorios[$nome]; //Captura os dados apenas do relatório em questão. Para melhorar a leitura
            if(isset($relatSelec['parame']))        //Se o relatório em questão não possuir parâmetros este aborta o mostrar campos necessário
                foreach ($relatSelec['parame'] as $cam => $aux) //Coloca os campos necessários visíveis ignorando os campos que não devem ser visibilidade alterada
                    if (in_array($cam, $this->campos))          //Somente os campos permissíveis são alterados
                        tk_set_visible_field($cam);
            if(isset($this->labels))                            //Verifica se há algum label para se resetar o valor (do label)
                foreach($this->labels as $cam => $lab)          //Reseta os nomes de labels
                    tk_set_field_label($cam, $lab);
            if(isset($relatSelec['rotulo']))                    //Verifica se há algum label de campos a serem re-setados
                foreach($relatSelec['rotulo'] as $cam => $lab)  //Seta um novo nome de campo, conforme o relatório exige
                    tk_set_field_label($cam, $lab);
            if(isset($relatSelec['requer']))                    //Verifica se há campos requeridos a serem setados com '*'
                foreach($relatSelec['requer'] as $aux)          //Coloca os campos necessários requeridos
                    tk_set_field_required($aux);
        } else {                                        //Se passar por aqui significa que o nome do relatório é inválido ou o mesmo não está integrado
            tk_warning(tk_get_message_by_name(self::msgNomInv, array($nome)));
        }
    }

    public function verificaVincEstrut(){               //Verifica multipla seleção no vínculo e estruturas
        $cont  = tk_get_field_value(self::vincu) != null ? 1 : 0;
        $cont += tk_get_field_value(self::esLeg) != null ? 1 : 0;
        $cont += tk_get_field_value(self::esGer) != null ? 1 : 0;
        if($cont > 1)   //Verifica se há mais de um campo preenchido
            tk_message(tk_get_message_by_name(self::msgMulEst));
    }

    public function abrirRelatorio(){                   //Abre o relatório selecionado
        $nome = $this->nomeRelatorio;
        switch($nome){
            case 'inicio':      //Se não foi selecionado um nome de relatório este lança um aviso ao usuário para fazê-lo
            case '':
                tk_warning(tk_get_message_by_name(self::msgSelRel));
                break;
            default:            //Todos os relatórios, inclusive as opções inválidas
                if(isset($this->relatorios[$nome])){                    //Verifica se o relatório existe
                    $cont = 0;                                          //Contador de campos requeridos nulos
                    foreach($this->relatorios[$nome]['requer'] as $aux) //Loop para verificar se um campo requerido (definido pelo nome do relatório) está nulo
                        $cont += tk_get_field_value($aux) == null ? 1 : 0;  //Se o campo for nulo incrementa o contador
                    if($cont == 0){                                     //Verifica se todos os campos marcados como requerido estão preenchidos
                        $param = array();                               //Array de parâmetros para a função tk_open_report_from_array abrir o relatório
                        foreach($this->relatorios[$nome]['parame'] as $cam => $par)
                            $param[$par] = tk_get_field_value($cam);
                        if($this->customizacao($param)){   //Verifica se existe alguma customização para o relatório em questão e se deve ou não executar o restante do bloco
                            tk_open_report_from_array($nome, $param, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
                        }
                    } else {    //Um ou mais campos requeridos não foram preenchidos
                        tk_warning(tk_get_message_by_name(self::msgFalPre));
                    }
                } else {        //Relatório não existe no array de configuração
                    tk_warning(tk_get_message_by_name(self::msgNomInv, array($nome)));
                }
        }
    }

    public function mostrarManual(){    //Exibi o manual do relatório em questão
        switch($this->nomeRelatorio){
            case 'inicio':  //Se não existir um nome de relatório este lança um aviso ao usuário
            case '':
                tk_warning(tk_get_message_by_name(self::msgSelRel));
                break;
            default:        //Todos os relatórios, inclusive as opções inválidas
                if(isset($this->relatorios[$this->nomeRelatorio])){   //Verifica se existe o relatório selecionado
                    if($this->relatorios[$this->nomeRelatorio]['manual'] != null){   //Verifica se existe manula para o relatório selecionado
                        tk_message($this->relatorios[$this->nomeRelatorio]['manual'], 'info', false);
                    }else{
                        tk_warning(tk_get_message_by_name(self::msgSemMan));    //Mensagem de ausência de relatório
                    }
                }else{      //Relatório selecionado inexistente no array de relatórios. Nome inválido.
                    tk_warning(tk_get_message_by_name(self::msgNomInv, array($this->nomeRelatorio)));
                }
        }
    }
}