/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: EXPORTA_REFORFIL

Descrio:
Exporta o cadastro de fornecedor no atende/atende de uma filial origem para uma
ou mais filiais destino

P_NRLISTA      - Lista de filiais destino
P_CDFILORIG    - Filial Origem

Criao:
06/09/2006 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE
PROCEDURE EXPORTA_REFORFIL
  (P_NRLISTA     IN VARCHAR2,
   P_CDFILORIG   IN VARCHAR2
   ) IS
      V_CONT_COMMIT NUMBER := 0;
      V_QTDE_COMMIT NUMBER := 500;
BEGIN
   FOR CUR_FILIAL IN
      (SELECT
          LISTA.CDLISTA
       FROM
          FILIAL,
          LISTA
       WHERE
          LISTA.NRLISTA = P_NRLISTA      AND
          LISTA.CDLISTA = FILIAL.CDFILIAL
       ORDER BY
          CDLISTA
       )
   LOOP
      DELETE FROM
         REFORFIL
      WHERE
         CDFILIAL = CUR_FILIAL.CDLISTA;

      FOR CUR_FORNECEDOR IN
         (SELECT
            R.CDFORNECED,
            CUR_FILIAL.CDLISTA,
            R.CDPERIENTR
         FROM
            REFORFIL R
         WHERE
            R.CDFILIAL = P_CDFILORIG
         )
      LOOP
         INSERT INTO
            REFORFIL(CDFORNECED, CDFILIAL, CDPERIENTR)
            VALUES  (CUR_FORNECEDOR.CDFORNECED, CUR_FORNECEDOR.CDLISTA, CUR_FORNECEDOR.CDPERIENTR);

         V_CONT_COMMIT    := V_CONT_COMMIT + 1;
         IF (V_CONT_COMMIT = V_QTDE_COMMIT) THEN
            V_CONT_COMMIT := 0;
            COMMIT;
         END IF;
      END LOOP;
   END LOOP;
COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_REFORFIL','5.20.000'); END;
/

